input:not([type=checkbox]):not([type=radio]),
textarea,
select {
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
}

input, textarea {
    outline: none;
    &:focus:required:invalid { border-color: red }
    &:required:valid { border-color: green }
}

:active, :hover, :focus {
    outline: 0 !important;
    outline-offset: 0 !important;
}

option::selection {background: #ccc;}
option::-moz-selection {background: #ccc;}
option::-webkit-selection {background: #ccc; color:#fff;}

input::-webkit-outer-spin-button,
input::-webkit-inner-spin-button {
    -webkit-appearance: none;
}

input[type='number'] {
    -moz-appearance: textfield;
}

.field {
    width: 100%;
    display: block;
    font-weight: 400;
    position: relative;
    border-radius: 6px;
    background: transparent;
    $input-selector: "input[type=text], input[type=email], input[type=password], input[type=number], textarea, select";

    #{$input-selector} {
        margin: 0;
        width: 100%;
        height: rem(42);
        outline: none;
        color: #333;
        box-shadow: none;
        font-weight: 400;
        font-size: rem(14);
        line-height: rem(24);
        padding: rem(8) rem(12);
        background: #fff;
        border-radius: 6px;
        display: inline-block;
        vertical-align: middle;
        border: rem(1) solid #CED4DA;
        @include placeholder(#333);

        &::-ms-clear {
            display: none;
            width: 0;
            height: 0;
        }

        &:focus,
        &:active {
            outline: none;
            @include placeholder(transparent);
        }


        &.error {
            border-color: red !important;
        }
    }

    textarea {
        height: auto;
        resize: none;
    }

    &__icon {
        fill: var(--color-primary);
        font-size: 0;
        line-height: 0;
        top: calc(50% - 11px);
        left: rem(10);
        height: 22px;
        position: absolute;
        display: inline-block;
    }

    &__arrow {
        z-index: 1;
        fill: #6C757D;
        font-size: 0;
        line-height: 0;
        display: inline-block;
        top: calc(50% - 0.625rem);
        right: rem(10);
        height: rem(20);
        position: absolute;
    }

    &__switcher {
        top: 1px;
        right: 1px;
        bottom: 1px;
        z-index: 30;
        border: none;
        outline: none;
        color: var(--color-primary);
        cursor: pointer;
        font-weight: 400;
        font-size: rem(14);
        line-height: rem(20);
        padding: 9px 10px;
        border-radius: 10px;
        white-space: nowrap;
        background: $white;
        position: absolute;
        display: block;
    }

    &__placeholder {
        top: 1px;
        right: 1px;
        bottom: 1px;
        z-index: 10;
        color: #BBBBBB;
        font-weight: 600;
        font-size: rem(14);
        line-height: rem(20);
        padding: 10px 10px;
        white-space: nowrap;
        position: absolute;
        display: block;
    }


    &--icon {

        #{$input-selector} {
            padding-left: rem(40);
        }
    }

    &--select {
        background: $white;

        #{$input-selector} {
            padding-right: rem(30);
            background: transparent;
        }
    }
}

.file-field {
    font-weight: 400;
    position: relative;

    input {
        top: 0;
        left: 0;
        width: 1px;
        height: 1px;
        opacity: 1;
        visibility: hidden;
        overflow: hidden;
        position: absolute;
    }

    span {
        max-width: 100%;
        display: block;
        overflow: hidden;
        text-overflow: ellipsis;

        &:before {
            content: attr(data-empty);
        }
    }

    &__label {
        font-weight: 400;
        font-size: rem(12);
    }
}
